
// XPort public GPS data structures
// (c) 2009 CuriousTech
//
// Release 1.0
//

typedef struct _SATDAT{
	WORD SatelliteNumber;
	WORD ElevationDegrees;
	WORD AzimuthDegreesTrue;
	WORD SignalToNoiseRatio;
} SATDAT;

#define MAX_SATS 12

typedef enum XPort_Status
{
	XPStatus_NotRunning,
	XPStatus_NoCom,
	XPStatus_Com,
	XPStatus_NMEA,
	XPStatus_SIRF,
};

typedef struct _GPSData{
	BYTE	bStatus;						// XPort connection status (0 = No XPort, 0 = Not connected, 1= Port connected, 2=Reading NMEA, 3=Reading SiRF)
	bool	bValidData;						// true = GPS data is currently valid (real or simulated)
	BYTE	ActiveComPort;					// COM port # being used
	bool	bSimulation;					// true = simulation (log playback)
	BYTE	ReferenceCount;					// Memory map reference count;
	BYTE	Reserved0[3];
	DWORD	Reserved1[3];
	SYSTEMTIME Time;						// Time (UTC)
	float	Latitude;
	float	Longitude;
	int 	GPSQuality;						// Fix Quality
	float	AltitudeMeters;
	float	GeoidalSeparationMeters;
	float	AgeOfDifferentialGPSDataSeconds;
	int 	DifferentialReferenceStationID;
	float	PDOP;
	float	HDOP;
	float	VDOP;
	BYTE	NumberOfSatellitesInUse;
	BYTE	OperatingMode;					// 0 = Inactive, 1 = Automatic, 2 = Manual
	BYTE	FixMode;						// 0 = Invalid, 1 = No fix, 2 = 2D Fix, 3 = 3D Fix
	BYTE	NumberOfSatellites;
	BYTE	SatelliteNumber[ MAX_SATS ];
	SATDAT	SatellitesInView[ MAX_SATS ];
	float	SpeedOverGroundKnots;
	float	TrackMadeGoodDegreesTrue;
	DWORD	Reserved2[4];
} GPSData;

